<script>
	import { dashboardStation } from '$lib/preferences';
	import { dashboardExtremes } from '$lib/Widgets/stores';
	import { strToDate } from '$lib/date';

	let url;

	const fetchData = () => {
		fetch(`${url}`)
			.then(async (req) => await req.json())
			.then((data) => {
				data.map((extreme) => {
					switch (extreme.type) {
						case 1:
							extreme.unit = '°C';
							break;
						case 2:
							extreme.unit = 'mm';
							break;
						case 3:
							extreme.unit = 'km/h';
							break;
						case 6:
							extreme.unit = '°C';
							break;
					}

					extreme.date = strToDate(extreme.date);

					return extreme;
				});
				dashboardExtremes.set([data[0], data[3], data[2], data[1]]);
			});
	};

	$: {
		url = `https://api.infoclimat.localhost/api/station/${$dashboardStation.id}/extremes`;
		fetchData();
	}
</script>

{#each $dashboardExtremes as extreme}
	{#if extreme}
		<dl
			class="px-4 py-5 bg-white shadow rounded-lg overflow-hidden sm:p-6 col-span-4 md:col-span-2 lg:col-span-1"
		>
			<dt class="text-sm font-medium text-gray-500">Record de {extreme.name.toLowerCase()}</dt>
			<p class="text-sm font-medium text-gray-400">Atteint le {extreme.date}</p>
			<dd
				class="mt-1 text-3xl font-semibold"
				class:red={extreme.type === 6}
				class:cyan={extreme.type === 1}
				class:coolGray={extreme.type === 3}
				class:blue={extreme.type === 2}
			>
				{extreme.type === 1 ? extreme.min : extreme.max}
				{extreme.unit}
			</dd>
		</dl>
	{/if}
{/each}

<style lang="postcss">
	.red {
		@apply text-red-500;
	}
	.cyan {
		@apply text-cyan-500;
	}
	.coolGray {
		@apply text-coolGray-500;
	}
	.blue {
		@apply text-blue-500;
	}
</style>
